/*
 * Device.java
 *
 * Created on 5. Dezember 2006, 11:29
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package de.vullriede.lazyLoading.model;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 * Entity class Device
 * 
 * @author g040037
 */
@Entity
@Table(name = "DEVICE")
@NamedQueries( {
        @NamedQuery(name = "Device.findById", query = "SELECT d FROM Device d WHERE d.id = :id"),
        @NamedQuery(name = "Device.findByName", query = "SELECT d FROM Device d WHERE d.name = :name")
    })
public class Device implements Serializable {

    @Id
    @Column(name = "ID", nullable = false)
    private BigDecimal id;

    @Column(name = "NAME", nullable = false)
    private String name;

    @JoinColumn(name = "LOCATION", referencedColumnName = "ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Location location;
    
    /** Creates a new instance of Device */
    public Device() {
    }

    /**
     * Creates a new instance of Device with the specified values.
     * @param id the id of the Device
     */
    public Device(BigDecimal id) {
        this.id = id;
    }

    /**
     * Creates a new instance of Device with the specified values.
     * @param id the id of the Device
     * @param name the name of the Device
     */
    public Device(BigDecimal id, String name) {
        this.id = id;
        this.name = name;
    }

    /**
     * Gets the id of this Device.
     * @return the id
     */
    public BigDecimal getId() {
        return this.id;
    }

    /**
     * Sets the id of this Device to the specified value.
     * @param id the new id
     */
    public void setId(BigDecimal id) {
        this.id = id;
    }

    /**
     * Gets the name of this Device.
     * @return the name
     */
    public String getName() {
        return this.name;
    }

    /**
     * Sets the name of this Device to the specified value.
     * @param name the new name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Gets the location of this Device.
     * @return the location
     */
    public Location getLocation() {
        return this.location;
    }

    /**
     * Sets the location of this Device to the specified value.
     * @param location the new location
     */
    public void setLocation(Location location) {
        this.location = location;
    }

    /**
     * Returns a hash code value for the object.  This implementation computes 
     * a hash code value based on the id fields in this object.
     * @return a hash code value for this object.
     */
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    /**
     * Determines whether another object is equal to this Device.  The result is 
     * <code>true</code> if and only if the argument is not null and is a Device object that 
     * has the same id field values as this object.
     * @param object the reference object with which to compare
     * @return <code>true</code> if this object is the same as the argument;
     * <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Device)) {
            return false;
        }
        Device other = (Device)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    /**
     * Returns a string representation of the object.  This implementation constructs 
     * that representation based on the id fields.
     * @return a string representation of the object.
     */
    @Override
    public String toString() {
        return "de.vullriede.lazyLoading.model.Device[id=" + id + "]";
    }
    
}
